routes/web.php
<?php

use Illuminate\Support\Facades\App;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::redirect('/', App::getLocale());
Route::group(['prefix' => '{locale}', 'middleware' => 'setlocale'], function () {
    Route::get('/', function () {
        return view('welcome');
    })->name('home');
    Route::resource('products', 'ProductController');
    Route::get('basket', function () {
        return view('basket');
    })->name('basket');
    Route::get('checkout', function () {
        return view('checkout');
    })->name('checkout');
    Route::get('addToCart/{id}/{name}/{price}', function ($l, $id, $name, $price) {
        // Session::flush();
        if (!Session::has('cart')) {
            Session::put('cart', []);
        }
        $totalBasket = floatval(Session::get('totalBasket'));
        Session::put('totalBasket', $totalBasket + $price);
        Session::push('cart', [$id, $name, $price]);
        Session::save();
        // dd(Session::all());
        return redirect()->back();
    })->name('addToCart');
});

app/Language.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Language extends Model
{
    //
}

app/Product.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Product extends Model
{
    public function translation()
    {
        return $this->hasMany('App\ProductTranslation');
    }
}

app/ProductTranslation.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class ProductTranslation extends Model
{
    function product()
    {
        return $this->belongsTo('App\Product');
    }
}

app/User.php
<?php

namespace App;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;

class User extends Authenticatable
{
    use Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/Controller.php
<?php

namespace App\Http\Controllers;

use Illuminate\Foundation\Auth\Access\AuthorizesRequests;
use Illuminate\Foundation\Bus\DispatchesJobs;
use Illuminate\Foundation\Validation\ValidatesRequests;
use Illuminate\Routing\Controller as BaseController;

class Controller extends BaseController
{
    use AuthorizesRequests, DispatchesJobs, ValidatesRequests;
}

app/Http/Controllers/ProductController.php
<?php

namespace App\Http\Controllers;

use App\Language;
use App\Product;
use App\ProductTranslation;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\App;

class ProductController extends Controller
{
    public function index()
    {
        $products = Product::whereHas('translation', function ($query) {
            $query->where('language_code', App::getLocale());
        })->with(['translation' => function ($query) {
            $query->where('language_code',  App::getLocale());
        }])->get();
        return view('allProducts', compact('products'));
    }

    public function create()
    {
        return view('create');
    }

    public function store($locale, Request $request)
    {
        $product = new Product();
        $product->price = $request->price;
        $product->save();
        // First Idea
        $product->translation[0] = new ProductTranslation();
        $product->translation[0]->product_id = $product->id;
        $product->translation[0]->language_code = App::getLocale();
        $product->translation[0]->title = $request->titleEn;
        $product->translation[0]->description = $request->descriptionEn;
        $product->translation[0]->save();

        // Second Idea
        // $languages = Language::all();
        // foreach ($languages as $i => $language) {
        //     $product->translation[$i] = new ProductTranslation();
        //     $product->translation[$i]->product_id = $product->id;
        //     $product->translation[$i]->language_code = $language->code;
        //     $product->translation[$i]->title = $request->title;
        //     $product->translation[$i]->description = $request->description;
        //     $product->translation[$i]->save();
        // }
        return redirect(route('products.index', [App::getLocale()]));
    }

    public function edit($locale, $id)
    {
        $product = Product::with(['translation' => function ($query) {
            $query->where('language_code',  App::getLocale());
        }])->where('id', $id)->first();
        return view('edit', compact('product'));
    }

    public function update($locale, $id, Request $request)
    {
        // Product::where('id', $id);
        $product = Product::where('id', $id)->with(['translation' => function ($query) {
            $query->where('language_code',  App::getLocale());
        }])->first();
        $product->price = $request->price;
        $product->translation[0]->title = $request->title;
        $product->translation[0]->description = $request->description;
        $product->translation[0]->save();
        $product->save();
        return redirect(route('products.index', [App::getLocale()]));
    }

    public function destroy($locale, $id)
    {
        Product::where('id', $id)->delete();
        return redirect()->back();
    }
}

resources/views/allProducts.blade.php
@extends('layouts.app')
@section('content')


<div class="container">
    <a href="{{ route('products.create',  App::getLocale() ) }}"
        class="btn btn-primary">{{ __('products_table.add') }}</a>
    <table id="datatable1" class="table table-striped table-bordered" cellspacing="0" width="100%">
        <thead>
            <tr>
                <th>ID</th>
                <th>{{ __('products_table.title') }}</th>
                <th>{{ __('products_table.desc') }}</th>
                <th>{{ __('products_table.price') }}</th>
                <th>Actions</th>
            </tr>
        </thead>
        <tbody>
            @foreach ($products as $product)
            <tr>
                <td class="id">{{ $product->id }}</td>
                <td class="name">{{ $product->translation[0]->title }}</td>
                <td>{{ $product->translation[0]->description }}</td>
                <td class="price">{{ $product->price }}</td>
                <td>
                    <a href='{{ route('products.edit', [App::getLocale(), $product->id]) }}'
                        class='btn btn-secondary'>{{ __('products_table.edit') }}</a>
                    <form action='{{ route('products.destroy', [App::getLocale() , $product->id]) }}' method='POST'
                        style='display:inline'>
                        @csrf
                        @method('delete')
                        <input onclick='return confirm("{{ __("home.delete_product_confirm_message") }}");'
                            type='submit' value=' {{ __('products_table.delete') }}' class='btn btn-danger'>
                    </form>
                    <button class="btn btn-primary add_to_cart">Add to cart</button>
                </td>
            </tr>
            @endforeach
        </tbody>
    </table>
</div>
<script>
    $(document).ready( function () {
        $('#datatable1').DataTable();
    });

    $('.add_to_cart').on('click', function(){
        var id = $(this).closest("tr").find('.id').text();
        var name = $(this).closest("tr").find('.name').text();
        var price = $(this).closest("tr").find('.price').text();
        window.location.href = "addToCart/" + id + "/" + name + "/" + price;
        // $("#totalBasket").text(parseFloat($("#totalBasket").text()) + parseFloat(price));
    });

</script>
@endsection

resources/views/basket.blade.php
@extends('layouts.app')
@section('content')
<style>
    .tableformat td:nth-child(1) {
        width: 700px;
    }
</style>
<div class="container">
    <div class="justify-content-md-center">
        <div class="text-center">
            <span style="font-size: 25px; font-weight: bold"> Basket</span>
            <hr width="30px" class="mb-5">
        </div>
        @if (session()->has('cart'))
        <div class="container">
            <div class="row">
                <div class="col-lg-7 col-md-7 col-sm-12">
                    <table class="table">
                        <thead>
                            <tr>
                                <th scope="col">PRODUCT</th>
                                <th scope="col">PRICE</th>
                                <th scope="col">QUANTITY</th>
                                <th scope="col">SUBTOTAL</th>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach (Session::get('cart') as $item)
                            <tr class="tableformat">
                                <td class="d-none">{{ $item[0] }}</td>
                                <td scope="row">{{ $item[1]}}</td>
                                <td>${{ $item[2] }}</td>
                                <td>
                                    <div class="row">
                                        <input type="button" class="col px-0 ml-2 text-center" value="-">
                                        <div class="col px-1 text-center pt-1">1</div>
                                        <input type="button" class="col px-0 mr-5 text-center" value="+">
                                    </div>
                                </td>
                                <td>${{ $item[2] }}</td>
                            </tr>
                            @endforeach
                        </tbody>
                    </table>
                </div>
                <div class="mx-2 d-none d-md-block d-lg-block" style="border-right: 1px solid grey; height: 500px">
                </div>
                <div class="col">
                    BASKET TOTALS
                    <hr>
                    <div class="row px-3">
                        Subtotal <span class="ml-auto">$65.00</span>
                    </div>
                    <hr>
                    <div class="row px-3">
                        Shipping
                        <div class="col px-0 ml-auto text-right">
                            Flat rate: $5.00
                            <div style="font-size: 12px;">
                                Shipping options will be updated during checkout.
                            </div>
                            Calculate shipping
                        </div>
                    </div>
                    <hr>
                    <div class="row px-3">
                        Total <span class="ml-auto">$70.00</span>
                    </div>

                    <hr>
                    <a href="{{ route('checkout', App::getLocale()) }}" class="btn btn-warning text-white"
                        style="width: 100%">Proceed to
                        checkout</a>
                    <div class="text-center py-2">— OR —</div>
                    <button class="btn btn-warning text-white" style="width: 100%">Paypal</button>
                    <div class="pb-2 pt-4"><i class="fas fa-tag"></i> Coupon</div>
                    <input class="input-group-text mb-3" style="display: block; width:100%" type="text"
                        placeholder="Coupon Code">
                    <button class="btn btn-outline-secondary" style="width: 100%;">Apply Coupon</button>
                </div>
            </div>
        </div>
        @else
        <div class="text-center">
            <div class="mb-3">
                Your basket is currently empty.
            </div>
            <a href="{{ route('products.index', App::getLocale()) }}" class="btn bg-dark text-white">RETURN TO SHOP</a>
        </div>
        @endif

    </div>
</div>
@endsection

resources/views/checkout.blade.php
@extends('layouts.app')
@section('content')
@php
$total =0;
@endphp
<div class="container">
    <div class="justify-content-md-center">
        <div class="text-center">
            <span style="font-size: 25px; font-weight: bold">
                <a href="" class="grey_no_underline">SHOPPING CART</a>
                <i class="fas fa-chevron-right grey_no_underline"></i>
                <a href="" class="grey_no_underline" style="color: black">CHECKOUT DETAILS</a>
                <i class="fas fa-chevron-right grey_no_underline"></i>
                <a href="" class="grey_no_underline ">ORDER COMPLETE</a>
            </span>
            <hr width="30px" class="mb-5">
        </div>

        {{-- <div class="mb-3">
            Your basket is currently empty.
        </div> 
        <a href="" class="btn bg-dark text-white">RETURN TO SHOP</a> --}}
        <div class="container">

            <div class="row">
                <div class="col-lg-7 col-md-7 col-sm-12">
                    Returning customer? <a href="">Click here to login</a>
                    <br>
                    Have a coupon? <a href=""> Click here to enter your code</a>
                    <hr>
                    BILLING DETAILS
                    <div class="row">
                        <div class="col">
                            <div class="py-2">First Name <span style="color: red">*</span></div>
                            <input class="input-group-text" style="width: 100%">
                        </div>
                        <div class=" col">
                            <div class="py-2">Last Name <span style="color: red">*</span></div>
                            <input class="input-group-text" style="width: 100%">
                        </div>
                    </div>
                    <div class="py-2">Company name (optional)</div>
                    <input class="input-group-text" style="width: 100%">
                    <div class="py-2">Country / Region <span style="color: red">*</span></div>
                    <input class="input-group-text" style="width: 100%">
                    <div class="py-2">Street address <span style="color: red">*</span></div>
                    <input class="input-group-text" style="width: 100%">
                    <div class="py-2">Town / City <span style="color: red">*</span></div>
                    <input class="input-group-text" style="width: 100%">
                    <div class="py-2">State / County <span style="color: red">*</span></div>
                    <input class="input-group-text" style="width: 100%">
                    <div class="py-2">Postcode / ZIP <span style="color: red">*</span></div>
                    <input class="input-group-text" style="width: 100%">
                    <div class="py-2">Phone <span style="color: red">*</span></div>
                    <input class="input-group-text" style="width: 100%">
                    <div class="py-2">Email address <span style="color: red">*</span></div>
                    <input class="input-group-text" style="width: 100%">
                    <div class="py-2">
                        <input type="checkbox"> Create an account?
                    </div>
                    <div class="py-2">
                        <input type="checkbox"> Deliver to a different address?
                    </div>
                    Order notes (optional)
                    <textarea name="" id="" rows="5" style="width:100%"
                        placeholder="Notes about your order, e.g. special notes for delivery."></textarea>
                </div>
                <div class="col border py-3" style="height: 770px">
                    YOUR ORDER

                    <table class="table">
                        <thead>
                            <tr>
                                <th scope="col">PRODUCT</th>
                                <th scope="col">SUBTOTAL</th>
                            </tr>
                        </thead>
                        <tbody>
                            @foreach (Session::get('cart') as $item)
                            <tr>
                                <td scope="row">{{ $item[1] }} × 1</td>
                                <td>${{ $item[2] }}</td>
                                @php
                                $total += $item[2];
                                @endphp
                            </tr>
                            @endforeach
                            <tr>
                                <td scope="row">Subtotal</td>
                                <td>${{ $total }}</td>
                            </tr>
                            <tr>
                                <td scope="row">Shipping</td>
                                <td>Flat rate: $5.00</td>
                            </tr>
                            <tr>
                                <td scope="row">Total</td>
                                <td>${{ $total + 5 }}</td>
                            </tr>
                        </tbody>
                    </table>
                    <hr>
                    <input type="radio"> Cash on delivery
                    <br>
                    Pay with cash upon delivery.
                    <hr>
                    <input type="radio"> Credit Card
                    <hr>
                    <input type="radio"> PayPal
                    <hr>
                    <input type="checkbox"> I have read and agree to the website terms and conditions *
                    <br>
                    <input type="button" value="PLACE ORDER" class="btn btn-warning text-white mt-2">
                    <div class="py-2">
                        Your personal data will be used to process your order, support your experience throughout this
                        website, and for other purposes described in our privacy policy.
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/create.blade.php
@extends('layouts.app')
@section('content')
<div class="container">
    <form method="POST" action="{{ route('products.store', [App::getLocale()]) }}">
        @csrf
        <div class="form-group">
            <label for="title">{{ __('products_table.title') }}</label>
            <input type="text" class="form-control" id="title" name="title">
        </div>
        <br>
        <div class="form-group">
            <label for="description">{{ __('products_table.desc') }}</label>
            <input type="text" class="form-control" id="description" name="description">
        </div>
        <br>
        <div class="form-group">
            <label for="price">{{ __('products_table.price') }}</label>
            <input type="number" class="form-control" id="price" name="price">
        </div>
        <br>
        <button type="submit" class="btn btn-primary">{{ __('products_table.add') }}</button>
    </form>
</div>
@endsection

resources/views/edit.blade.php
@extends('layouts.app')
@section('content')
<div class="container">
    <form method="POST" action="{{ route('products.update', [ App::getLocale(), $product]) }}">
        @csrf
        @method("PUT")
        <div class="form-group">
            <label for="title">{{ __('products_table.title') }}</label>
            <input type="text" class="form-control" placeholder="" id="title" name="title"
                value="{{ $product->translation[0]->title }}">
        </div>
        <br>
        <div class="form-group">
            <label for="description">{{ __('products_table.desc') }}</label>
            <input type="text" class="form-control" placeholder="" id="description" name="description"
                value="{{ $product->translation[0]->description }}">
        </div>
        <br>
        <div class="form-group">
            <label for="price">{{ __('products_table.price') }}</label>
            <input type="number" class="form-control" placeholder="" id="price" name="price"
                value="{{ $product->price }}">
        </div>
        <br>
        <button type="submit" class="btn btn-primary">Submit</button>
    </form>
</div>
@endsection